 /***************************************************************
 *                                                              *  
 *    o_convert1.S                                              *
 *    image/color conversion routines;                          *
 *    Assembler part                                            *
 *                                                              *
 *    (G) corTeX / Optimum   1999-02-04                         *
 *    http://www.citeweb.net/optimum                            *
 *                                                              *
 *    (G) Gnu GPL                                               *
 ***************************************************************/

	
.text


.global ofn_cvrt_ABGR_8888_RGB_565
.global ofn_cvrt_bRGBA_8888_RGB_565
.global ofn_cvrt_mRGBA_8888_RGB_565
.global ofn_cvrt_lABGR_8888_RGB_565

.global ofn_cvrt_ARGB_8888_RGB_565
.global ofn_cvrt_bBGRA_8888_RGB_565
.global ofn_cvrt_mBGRA_8888_RGB_565
.global ofn_cvrt_lARGB_8888_RGB_565
	
.global ofn_cvrt_RGB_565_ARGB_8888
.global ofn_cvrt_RGB_565_bBGRA_8888
.global ofn_cvrt_RGB_565_mBGRA_8888
.global ofn_cvrt_RGB_565_lARGB_8888	

.global ofn_cvrt_RGB_565_ABGR_8888
.global ofn_cvrt_RGB_565_bRGBA_8888
.global ofn_cvrt_RGB_565_mRGBA_8888
.global ofn_cvrt_RGB_565_lABGR_8888	

	
.global ofn_cvrt_P_8_P_16
###.global ofn_cvrt_P_8_P_32

	.type	 ofn_cvrt_ABGR_8888_RGB_565,@function
	.type	 ofn_cvrt_bRGBA_8888_RGB_565,@function
	.type	 ofn_cvrt_mRGBA_8888_RGB_565,@function
	.type	 ofn_cvrt_lABGR_8888_RGB_565,@function
	
	.type	 ofn_cvrt_ARGB_8888_RGB_565,@function
	.type	 ofn_cvrt_bBGRA_8888_RGB_565,@function
	.type	 ofn_cvrt_mBGRA_8888_RGB_565,@function
	.type	 ofn_cvrt_lARGB_8888_RGB_565,@function
	
	.type	 ofn_cvrt_RGB_565_ARGB_8888,@function
	.type	 ofn_cvrt_RGB_565_bBGRA_8888,@function
	.type	 ofn_cvrt_RGB_565_mBGRA_8888,@function
	.type	 ofn_cvrt_RGB_565_lARGB_8888,@function

	
	.type	 ofn_cvrt_RGB_565_ABGR_8888,@function
	.type	 ofn_cvrt_RGB_565_bRGBA_8888,@function
	.type	 ofn_cvrt_RGB_565_mRGBA_8888,@function
	.type	 ofn_cvrt_RGB_565_lABGR_8888,@function
	
	.type	 ofn_cvrt_P_8_P_16,@function
###	.type	 ofn_cvrt_P_8_P_32,@function


ofn_cvrt_ABGR_8888_RGB_565:
ofn_cvrt_bRGBA_8888_RGB_565:
ofn_cvrt_mRGBA_8888_RGB_565:
ofn_cvrt_lABGR_8888_RGB_565:	
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	movl	8(%ebp),%esi       //# load src and dst ptr,
	movl   12(%ebp),%edi 
	movl   16(%ebp),%ecx       //# and number of pixels

		 
	subl	$2,%edi		//        will be re-added in the loop (for pairability)
	
.align 16, 0x90			//	align loop start for efficiency;fill with nops(90)
1:
	movl	(%esi),%eax	# 
	addl    $4,%esi		# 

	movb    %al,%dl		//       R
	andl    $0x00ffff00,%eax//        keep only BG
	
	shll    $8,%eax		//        ABGR => BGR0  ( BG00 in fact)
	andb    $0xf8,%dl       //        zeroe 3 low bits of R
	
	bswapl  %eax            //      Rearange BGR0 into 0RGB (00GB)

	
	shrb	$2,%ah          //       shift G (8bits ->6bits)
	addl	$2,%edi		//        next dest. pixel

	shrl	$3,%eax		//       shift B (8bits -> 5bits) and put GB on position

	orb     %dl,%ah		//        mix R with GB
	
	movw    %ax,(%edi)	
	nop
	
	decl	%ecx		
	jnz	1b		
	
	popl	%ebx
	popl	%edi
	popl	%esi	
	leave
	ret

ofn_cvrt_ARGB_8888_RGB_565:	
ofn_cvrt_bBGRA_8888_RGB_565:	
ofn_cvrt_mBGRA_8888_RGB_565:	
ofn_cvrt_lARGB_8888_RGB_565:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	
	movl	8(%ebp),%esi       // load src and dst ptr,
	movl   12(%ebp),%edi 
	movl   16(%ebp),%ecx        // and number of pixels

		 
	subl	$2,%edi		//        will be re-added in the loop (for pairability)
	
.align 16, 0x90			//	align loop start for efficiency; fill with nops(90)
1:
	movl	(%esi),%eax	
	addl    $4,%esi		

	movl    %eax,%edx	//       
	andl    $0x0000ffff,%eax//        keep only GB
	
	shrl	$16,%edx	//       R into dl

	shrb	$2,%ah          //       shift G (8bits ->6bits)
	addl	$2,%edi		//        next dest. pixel

	shrl	$3,%eax		//       shift B (8bits -> 5bits) and put GB on position
	andb    $0xf8,%dl       //        zeroe 3 low bits of R
	
	orb     %dl,%ah		//        mix R with GB
	
	movw    %ax,(%edi)	
	nop
	
	decl	%ecx		
	jnz	1b		
	
	popl	%ebx
	popl	%edi
	popl	%esi
		
	leave
	ret

	



ofn_cvrt_RGB_565_ARGB_8888:
ofn_cvrt_RGB_565_bBGRA_8888:
ofn_cvrt_RGB_565_mBGRA_8888:
ofn_cvrt_RGB_565_lARGB_8888:	
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
		
	movl	8(%ebp),%esi        // load src and dst ptr,
	movl   12(%ebp),%edi 
	movl   16(%ebp),%ecx        // and number of pixels

.align 16, 0x90
1:
	movw	(%esi,%ecx,2),%ax	
	movl	%eax,%ebx	
	
	shll	$3,%eax		//     shift  B and ~G
	andl	$0xf800,%ebx	// 	isolate R
	
	shll	$8,%ebx		// 	set R in position
	andl	$0xffff,%eax	//      clear upper word for future R
	
	shlb	$2,%ah		// 	shift G
	
	orl	%eax,%ebx	// 	mix 0R GB

	movl	%ebx,(%edi,%ecx,4)	
	nop			
	
	
	decl	%ecx		
	jnz	1b		
	
	popl	%ebx
	popl	%edi
	popl	%esi
	leave
	ret








ofn_cvrt_RGB_565_ABGR_8888:
ofn_cvrt_RGB_565_bRGBA_8888:
ofn_cvrt_RGB_565_mRGBA_8888:
ofn_cvrt_RGB_565_lABGR_8888:	
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
		
	movl	8(%ebp),%esi        // load src and dst ptr,
	movl   12(%ebp),%edi 
	movl   16(%ebp),%ecx        // and number of pixels

.align 16, 0x90
1:
	movw	(%esi,%ecx,2),%ax	
	movl	%eax,%ebx	
	
	shll	$3,%eax		//     shift  B and ~G
	andl	$0xf800,%ebx	// 	isolate R
	
	shll	$8,%ebx		// 	set R in position
	andl	$0xffff,%eax	//      clear upper word for future R
	
	shlb	$2,%ah		// 	shift G
	
	orl	%eax,%ebx	// 	mix 0R GB

	bswapl	%ebx                      // completely suboptimal
	shrl	$8,%ebx
	movl	%ebx,(%edi,%ecx,4)	
	nop			
	
	
	decl	%ecx		
	jnz	1b		
	
	popl	%ebx
	popl	%edi
	popl	%esi
	leave
	ret




ofn_cvrt_P_8_P_16:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
		
	movl	8(%ebp),%esi        # load src and dst ptr,
	movl	12(%ebp),%edi 
	movl	16(%ebp),%ecx	    # number of pixels
	movl	20(%ebp),%ebx	    # palette
	
	addl	%ecx,%esi		# partir de la fin pour partir du debut (hem)
	movl	%ecx,%eax
	shll	$1,%eax
	addl	%eax,%edi
	shrl	$2,%ecx			# 4 pixels / loop
	negl	%ecx
.align 16,0x90
1:	
	movl	(%esi,%ecx,4),%edx
	xorl	%eax,%eax
	
	pushl	%esi
	movb	%dh,%al
	
	movw	(%ebx,%eax,2),%si
	movb	%dl,%al

	shll	$16,%esi
	andl	$0xffff0000,%edx

	movw	(%ebx,%eax,2),%si
	nop

	shrl	$16,%edx
	movl	%esi,(%edi,%ecx,8)	###

	movb	%dh,%al
	andl	$0xff,%edx

	movw	(%ebx,%eax,2),%ax
	popl	%esi

	shll	$16,%eax
	nop
	
	movw	(%ebx,%edx,2),%ax
	nop

	movl	%eax,4(%edi,%ecx,8)
	nop
	
	incl	%ecx		
	js	1b		
	
	popl	%ebx
	popl	%edi
	popl	%esi
	leave
	ret




###ofn_cvrt_P_8_P_32:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
		
	movl	8(%ebp),%esi        # load src and dst ptr,
	movl	12(%ebp),%edi 
	movl	16(%ebp),%ecx	    # number of pixels
	movl	20(%ebp),%ebx	    # palette
	
	addl	%ecx,%esi
	movl	%ecx,%eax
	shll	$2,%eax
	addl	%eax,%edi
	shrl	$2,%ecx			# 4 pixels / loop
	negl	%ecx
	pushl	%ebp
	
.align 16,0x90
1:	
	movl	(%esi,%ecx,4),%edx
	xorl	%eax,%eax
	
	pushl	%esi
	movb	%dl,%al
	
	movl	(%ebx,%eax,4),%esi
	movb	%dh,%al

	movl	(%ebx,%eax,4),%ebp
	movl	%esi,(%edi,%ecx,8)

	shrl	$16,%edx
	movl	%ebp,4(%edi,%ecx,8)

	movb	%dh,%al
	andl	$0xff,%edx

	movl	(%ebx,%eax,4),%eax
	popl	%esi

	movl	(%ebx,%edx,4),%edx
	movl	%eax,12(%edi,%ecx,8)
	
	movl	%edx,8(%edi,%ecx,8)
	nop
	
	incl	%ecx		
	js	1b		

	popl	%ebp
	popl	%ebx
	popl	%edi
	popl	%esi
	leave
	ret
